// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/10/06 
//
//-------------------------------------------------------------------// AvalVideoDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "AvalVideo.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"
#include "AvalVideoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TIMER_ID_GRAB 1		

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAvalVideoDlg _CAO

CAvalVideoDlg::CAvalVideoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAvalVideoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAvalVideoDlg)
	m_ascope = FALSE;
	m_trigger = -1;
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAvalVideoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAvalVideoDlg)
	DDX_Check(pDX, IDC_ASCOPE, m_ascope);
	DDX_CBIndex(pDX, IDC_TRIGGER, m_trigger);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAvalVideoDlg, CDialog)
	//{{AFX_MSG_MAP(CAvalVideoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_ASCOPE, OnAscope)
	ON_BN_CLICKED(IDC_DISP1, OnDisp1)
	ON_BN_CLICKED(IDC_DISPFULL, OnDispfull)
	ON_BN_CLICKED(IDC_DISPPLUS, OnDispplus)
	ON_BN_CLICKED(IDC_DISPMINUS, OnDispminus)
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_GRAB, OnGrab)
	ON_BN_CLICKED(IDC_FREERUN, OnFreerun)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_RESETVIDEOCONFFILE, OnResetvideoconffile)
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_CBN_SELCHANGE(IDC_TRIGGER, OnSelchangeTrigger)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAvalVideoDlg bZ[W nh

BOOL CAvalVideoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize(NULL);
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no = 0;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem(IDC_FVXDISPLAYEX1);		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface(__uuidof(IFvxDisplayEx2Ptr),(void**)&m_FvxDisplayEx);

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxImage1.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo_Aval.CreateInstance( __uuidof( FvxVideo_Aval ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		
		// rfIfoCX̃I[vԕێϐ̏
		m_blnVideoOpened = false;
		GetDlgItem(IDC_GRAB)->EnableWindow(FALSE);
		GetDlgItem(IDC_FREERUN)->EnableWindow(FALSE);

		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay(1,0);

		// rfIfoCXI
		setVideoConfFile();

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}
	
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CAvalVideoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CAvalVideoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CAvalVideoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAvalVideoDlg::setVideoConfFile()
{
    long lngCaptureType = 0;			// Lv`{[h̃^Cv(0=RICE/1=FVC01/2=FVC02)
    long lngCaptureNum = 0;				// Lv`{[h̖
    long lngCaptureConnectorNum = 0;	//P{[h̃RlN^
	long err_no = 0;
	long j=0;
	CString str;

	CConfFileDlg fdlg;
    
    if ( m_blnVideoOpened ) {
        // rfIfoCXI[vĂꍇ͈UN[Y܂
        m_FvxVideo_Aval->CloseDevice();
        m_blnVideoOpened = false;
	}

	// rfIݒt@C̑I
	fdlg.DoModal();

	if (fdlg.m_conffile.GetLength() != 0) {
		
		// rfIݒt@CR|[lgɐݒ
 		m_FvxVideo_Aval->PutVideoConfFile( _bstr_t( fdlg.m_conffile ) );

		// rfIfoCXI[v
		try {

			m_FvxVideo_Aval->OpenDevice();

		} catch( _com_error ) {
		
			m_FvxVideo_Aval->GetErrReport( &err_no );
			MessageBox("rfIfoCX̃I[vɎs܂" , "G[" , MB_ICONWARNING | MB_OK );
			return;
		}

		// rfIfoCX̏ԂL
		m_blnVideoOpened = true;

		// J荞ݗL
		GetDlgItem(IDC_GRAB)->EnableWindow(TRUE);
		GetDlgItem(IDC_FREERUN)->EnableWindow(TRUE);

		// gK[h
		CComboBox*    pcmb;
		pcmb = ( CComboBox* )GetDlgItem( IDC_TRIGGER );
		pcmb->ResetContent();
		pcmb->AddString( "m[}" );
		pcmb->AddString( "gK" );
		pcmb->AddString( "OgK" );
		m_trigger = 0 ;

		// ̃gK[h̐ݒ
		m_FvxVideo_Aval->GetCaptureType( &lngCaptureType );

		if (lngCaptureType == 12) {  /* FHC3328̓gKݒłȂEnableFalseɂ */
			GetDlgItem(IDC_TRIGGER)->EnableWindow(FALSE);
		} else {
			GetDlgItem(IDC_TRIGGER)->EnableWindow(TRUE);
		}

		// GrabSync/GrabASync\bhłImegeTCY̕ύXsŁA
        // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
        // i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
		m_FvxVideo_Aval->ChangeImageSize(m_FvxImage1);

	}
	
	// 摜̕\
	m_FvxDisplayEx->DrawImage(m_FvxImage1);

	UpdateData(FALSE);

}

// AScope\؂ւ
void CAvalVideoDlg::OnAscope() 
{
	if ( !UpdateData(TRUE) ) return;

	if (m_ascope) {
		m_FvxDisplayEx->PutAScopeMode( DISPLAYEX_AScopeAuto );
	} else {
		m_FvxDisplayEx->PutAScopeMode( DISPLAYEX_AScopeDisable );
	}
	
}

// {\
void CAvalVideoDlg::OnDisp1() 
{
    m_FvxDisplayEx->PutMagnification( 1 );
	GetDlgItem(IDC_DISPPLUS)->EnableWindow( TRUE );
	GetDlgItem(IDC_DISPMINUS)->EnableWindow( TRUE );	
	
}

// tʕ\
void CAvalVideoDlg::OnDispfull() 
{
	CRect rect;

	GetDlgItem( IDC_FVXDISPLAYEX1 )->GetWindowRect( rect );

	// XN[WNCAgWɕϊ
	ScreenToClient( rect );

    double dblScaleX = ( (double)( rect.right - rect.left )) / m_FvxImage1->GetImageWidth();
    double dblScaleY = ( (double)( rect.bottom - rect.top )) / m_FvxImage1->GetImageHeight();
   

	if ( dblScaleX < dblScaleY ) {
        m_FvxDisplayEx->PutMagnification( dblScaleX );
    } else {
        m_FvxDisplayEx->PutMagnification( dblScaleY );
	}
			
	GetDlgItem(IDC_DISPPLUS)->EnableWindow( TRUE );
	GetDlgItem(IDC_DISPMINUS)->EnableWindow( TRUE );	
}

// \{plus
void CAvalVideoDlg::OnDispplus() 
{
	m_FvxDisplayEx->PutMagnification( m_FvxDisplayEx->GetMagnification() + 0.1 );
    if ( m_FvxDisplayEx->GetMagnification() > 4) {
		GetDlgItem(IDC_DISPPLUS)->EnableWindow( FALSE );	
    } else {
		GetDlgItem(IDC_DISPPLUS)->EnableWindow( TRUE );	
	}
	GetDlgItem(IDC_DISPMINUS)->EnableWindow( TRUE );	
	
}

// \{minus
void CAvalVideoDlg::OnDispminus() 
{
	m_FvxDisplayEx->PutMagnification( m_FvxDisplayEx->GetMagnification() - 0.1 );
    if ( m_FvxDisplayEx->GetMagnification()  <  0.5   ) {
		GetDlgItem(IDC_DISPMINUS)->EnableWindow( FALSE );
    } else {
		GetDlgItem(IDC_DISPMINUS)->EnableWindow( TRUE );
	}
	GetDlgItem(IDC_DISPPLUS)->EnableWindow( TRUE );	
	
}

BOOL CAvalVideoDlg::PreTranslateMessage(MSG* pMsg) 
{
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}

void CAvalVideoDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
    // rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo_Aval->CloseDevice();	
	}	
	
}

void CAvalVideoDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}
	}	
	
}

// J荞
void CAvalVideoDlg::OnGrab() 
{
	CString str;

    m_FvxPerformanceCounter->StartCount();		// ԑJn
    
	try {
		// 捞
		m_FvxVideo_Aval->GrabSync( m_FvxImage1 );
	} catch (_com_error) {

	    long lngErr = 0;
		m_FvxVideo_Aval->GetErrReport( &lngErr );
		
		str.Format("捞G[ ( %d,)",lngErr);
		if (lngErr != 0) {
			MessageBox(str, "G[" , MB_ICONWARNING | MB_OK );
		}
	}

    double dblTime = 0;
	m_FvxPerformanceCounter->StopCount( &dblTime );   // ԑI
    
    // 荞񂾉摜ʂɕ\
	m_FvxDisplayEx->DrawImage( m_FvxImage1 );
    
    str.Format("%.2fms",dblTime);
	GetDlgItem(IDC_GRABTIME)->SetWindowText( str );
	
}

// t[JnE~
void CAvalVideoDlg::OnFreerun() 
{
    if ( m_intIsFreerun == 1 ) {
		GetDlgItem( IDC_GRAB )->EnableWindow(TRUE);
		GetDlgItem(IDC_FREERUN)->SetWindowText("Freerun");
		KillTimer( TIMER_ID_GRAB );
		m_intIsFreerun = 0;
	} else {
		SetTimer( TIMER_ID_GRAB, 50, NULL );
		GetDlgItem( IDC_GRAB )->EnableWindow(FALSE);
		GetDlgItem(IDC_FREERUN)->SetWindowText("Stop");
		m_intIsFreerun = 1;
	}
	
}

void CAvalVideoDlg::OnTimer(UINT nIDEvent) 
{
	switch( nIDEvent ){
		case TIMER_ID_GRAB:

			if ( m_blnVideoOpened ) {

				try {
					// ԑJn
					m_FvxPerformanceCounter->StartCount();   
					// 捞
					m_FvxVideo_Aval->GrabSync( m_FvxImage1 );
					// ԑI
					double dblTime = 0;
					m_FvxPerformanceCounter->StopCount( &dblTime );
					// 摜\
					m_FvxDisplayEx->DrawImage( m_FvxImage1 );
					CString szTmp;
					szTmp.Format("%.2fms",dblTime);
					GetDlgItem(IDC_GRABTIME)->SetWindowText(szTmp);
				} catch( _com_error ) {
					long err_no=0;
					CString szErr;
					m_FvxVideo_Aval->GetErrReport( &err_no );
					szErr.Format("捞G[( %d )",err_no);
					MessageBox(szErr, "G[" , MB_ICONWARNING | MB_OK );
					KillTimer( TIMER_ID_GRAB );
					m_intIsFreerun = 0;
					return;
				}
			}
	}
	
	CDialog::OnTimer(nIDEvent);
}

// rfIݒt@CĐݒ
void CAvalVideoDlg::OnResetvideoconffile() 
{
	// t[Ȃ΁A~B
    if ( m_intIsFreerun == 1 ) {
		GetDlgItem( IDC_GRAB )->EnableWindow(TRUE);
		GetDlgItem(IDC_FREERUN)->SetWindowText("Freerun");
		KillTimer( TIMER_ID_GRAB );
		m_intIsFreerun = 0;
	}
    
    // rfIfoCX̑I
    setVideoConfFile();

}

// \摜ۑ
void CAvalVideoDlg::OnSaveimage() 
{
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t( cFileDlg.GetPathName() ));

		try {
		
			m_FvxFileAccess->SaveBitmap( m_FvxImage1 );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}
}

// gK[h̕ύX
void CAvalVideoDlg::OnSelchangeTrigger() 
{
    if (!UpdateData(TRUE)) return;
    if ( m_blnVideoOpened ) {
		try {

			m_FvxVideo_Aval->SetTrigger( m_trigger );

		} catch ( _com_error) {
	        
			long lngErr = 0;
			CString cStr;

			m_FvxVideo_Aval->GetErrReport(&lngErr);
			cStr.Format("gK[[h̕ύX͂ł܂ł %d",lngErr);
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);

		}
	}	

}
